//
// C++ Implementation: myframe
//
// Description: 
//
//
// Author: Al Williams <alw@al-williams.com>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "wx/wx.h" 
#include "wx/event.h"
#include "wx/sizer.h"
extern "C" {
#include "tone.h"
}
 
#include "myapp.h"
#include "myframe.h"

// This sets the positions of the keys so they look like a keypad
static int keypos[]= { 0,0,1,2,3,4,5,6,7,8,9,11,3,7,11,15 };

/**
 * Myframe constructor
 * @param title The window title
 * @param pos The position of the window
 * @param size the size of the window
 * @return none
 */
MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size,    
	  wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX | wxCLIP_CHILDREN)
{
    wxMenu *menuFile = new wxMenu;
    menuFile->AppendCheckItem(ID_Tone,"&DialTone")->Check();
    menuFile->AppendSeparator();
    menuFile->Append( ID_About, "&About..." );
    menuFile->Append( ID_Quit, "E&xit" );
    wxMenuBar *menuBar = new wxMenuBar;
    menuBar->Append( menuFile, "&File" );
 
    SetMenuBar( menuBar );

    panel=new wxPanel(this);
    sizer0=new wxBoxSizer(wxVERTICAL);
    sizer=new wxGridSizer(4,4,5,5);
    for (int i=0;i<16;i++)
      {
        wxString digits("0123456789*#ABCD");
	buttons[i]=new wxButton(panel,i,digits.Mid(i,1),wxDefaultPosition,
				wxSize(30,20));
	sizer->Insert(keypos[i],buttons[i],wxALIGN_CENTER);
      }
    sizer0->Add(sizer);
    SetSizer(sizer0);
    panel->SetSizer(sizer);
    sizer->Fit(panel);
    sizer0->Fit(this);
    panel->SetFocus(); // on Linux  this works; Windows, seems like this doesn't work but this->SetFocus does so I'm trying both
    this->SetFocus();
    // haven't tested this on Linux, but if it doesn't work
    // it will require a #if __WIN32 or something

}

bool MyFrame::Destroy(void)
{
  sizer0->Detach(0); // prevent seg fault on exit
  return wxFrame::Destroy();
}

void MyFrame::OnChar(wxKeyEvent &event)
{
  audioDial(event.GetKeyCode());
}

void MyFrame::OnTone(wxCommandEvent& event)
{
  static int tone=1;
  tone=!tone;
  setFrequency(tone?350.0:0.0,2);  // dial tone
  ((wxMenuItem *)event.GetEventObject())->Check(tone!=0);
}

void MyFrame::OnBtn(wxCommandEvent& event)
{
  int n=event.GetId();
  audioDial(n); 
  SetFocus();  // make sure frame has focus for keystrokes
}

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}
 
void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{

    wxMessageBox("DTMF Encoder by Al Williams",
        "About TTONE", wxOK | wxICON_INFORMATION, this);
}
