/*
 * Touch tone generator
 * Williams
 */
 
#include "wx/wx.h" 
#include "wx/event.h"
#include "wx/sizer.h"
extern "C" {
#include "tone.h"
}
 
#include "myapp.h"
#include "myframe.h"

 
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU(ID_Quit, MyFrame::OnQuit)
    EVT_MENU(ID_About, MyFrame::OnAbout)
  EVT_COMMAND_RANGE(0,15,wxEVT_COMMAND_BUTTON_CLICKED,MyFrame::OnBtn)
  EVT_CHAR(MyFrame::OnChar)
END_EVENT_TABLE()
 
IMPLEMENT_APP(MyApp)

  int MyApp::OnExit()
{
  audioEnd(audio);
  return wxApp::OnExit();
}

bool MyApp::OnInit()
{
    if (audioInit(&audio)) 
      {
      printf("Audio init failed\n");
      return false;
      }
    MyFrame *frame = new MyFrame( "DTMF",wxDefaultPosition,wxDefaultSize);
				  //         wxPoint(50,50), wxSize(155,120));
    frame->Show(TRUE);
    SetTopWindow(frame);
    return TRUE;
} 
 
int keypos[]= { 0,0,1,2,3,4,5,6,7,8,9,11,3,7,11,15 };

MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size,    
	  wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX | wxCLIP_CHILDREN)
{
    wxMenu *menuFile = new wxMenu;
    menuFile->Append( ID_About, "&About..." );
    menuFile->AppendSeparator();
    menuFile->Append( ID_Quit, "E&xit" );
 
    wxMenuBar *menuBar = new wxMenuBar;
    menuBar->Append( menuFile, "&File" );
 
    SetMenuBar( menuBar );

    panel=new wxPanel(this);
    sizer0=new wxBoxSizer(wxVERTICAL);
    sizer=new wxGridSizer(4,4,5,5);
    for (int i=0;i<16;i++)
      {
        wxString digits("0123456789*#ABCD");
	buttons[i]=new wxButton(panel,i,digits.Mid(i,1),wxDefaultPosition,
				wxSize(30,20));
	sizer->Insert(keypos[i],buttons[i],wxALIGN_CENTER);
      }
    sizer0->Add(sizer);
    SetSizer(sizer0);
    panel->SetSizer(sizer);
    sizer->Fit(panel);
    sizer0->Fit(this);
    panel->SetFocus(); // on Linux  this works; Windows, seems like this doesn't work but this->SetFocus does
}

bool MyFrame::Destroy(void)
{
  sizer0->Detach(0); // prevent seg fault on exit
  return wxFrame::Destroy();
}

void MyFrame::OnChar(wxKeyEvent &event)
{
  audioDial(event.GetKeyCode());
}

void MyFrame::OnBtn(wxCommandEvent& event)
{
  int n=event.GetId();
  audioDial(n); 
  SetFocus();  // make sure frame has focus for keystrokes
}

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}
 
void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{

    wxMessageBox("DTMF Encoder by Al Williams",
        "About TTONE", wxOK | wxICON_INFORMATION, this);
}
