/*
 * Touch tone generator
 * Williams
 */
 
#include "wx/wx.h" 
#include "wx/event.h"
#include "wx/sizer.h"
extern "C" {
#include "tone.h"
}
 
#include "myapp.h"
#include "myframe.h"

 
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU(ID_Quit, MyFrame::OnQuit)
    EVT_MENU(ID_About, MyFrame::OnAbout)
  EVT_COMMAND_RANGE(0,15,wxEVT_COMMAND_BUTTON_CLICKED,MyFrame::OnBtn)
  EVT_CHAR(MyFrame::OnChar)
END_EVENT_TABLE()
 
IMPLEMENT_APP(MyApp)

  int MyApp::OnExit()
{
  audioEnd(audio);
  return wxApp::OnExit();
}

bool MyApp::OnInit()
{
    if (audioInit(&audio)) 
      {
      printf("Audio init failed\n");
      return false;
      }
    MyFrame *frame = new MyFrame( "DTMF",
         wxPoint(50,50), wxSize(155,120));
    frame->Show(TRUE);
    SetTopWindow(frame);
    return TRUE;
} 
 
MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size,    
	  wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX | wxCLIP_CHILDREN)
{
    wxMenu *menuFile = new wxMenu;
    menuFile->Append( ID_About, "&About..." );
    menuFile->AppendSeparator();
    menuFile->Append( ID_Quit, "E&xit" );
 
    wxMenuBar *menuBar = new wxMenuBar;
    menuBar->Append( menuFile, "&File" );
 
    SetMenuBar( menuBar );

    panel=new wxPanel(this);

    for (int i=0;i<16;i++)
      {
        wxString digits("0123456789*#ABCD");
	wxPoint pt[]={ wxPoint(40,75), 
		       wxPoint(0,0), wxPoint(40,0), wxPoint(80,0), 
		       wxPoint(0,25),  wxPoint(40,25), wxPoint(80,25), 
		       wxPoint(0,50), wxPoint(40,50), wxPoint(80,50),
		       wxPoint(0,75), wxPoint(80,75),
		       wxPoint(120,0), wxPoint(120,25), wxPoint(120,50), 
		       wxPoint(120,75)};
	buttons[i]=new wxButton(panel,i,digits.Mid(i,1),pt[i],
				wxSize(30,20));
      }
    // probably ought to use one of the wx layout managers
    wxSize bsize=buttons[0]->GetSize();
    this->SetSize(wxSize(bsize.GetWidth()*6,bsize.GetHeight()*8));

    panel->SetFocus();

}

 
void MyFrame::OnChar(wxKeyEvent &event)
{
  audioDial(event.GetKeyCode());
}

void MyFrame::OnBtn(wxCommandEvent& event)
{
  int n=event.GetId();
  audioDial(n); 
}

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}
 
void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{

    wxMessageBox("DTMF Encoder by Al Williams",
        "About TTONE", wxOK | wxICON_INFORMATION, this);
}
